<?php

$movies_dir = './assets/movies/';
$menus_dir = './assets/menu/';
$tmp_dir = './tmp/';
$dvdauthor_xml = './dvdauthor-project.xml';
$output_dir = './output';
$data_dir = './extras';
$output_iso = "escena.org_dvd1_2008_v1.1.iso";

$desired_width = 720;
$desired_height = 576;

$vob_files = array();

// info is: title, group, type, party
$playlist = array
(
	'rgba_kindercrasher.avi'	=>	array('Kindercrasher', 'RGBA', 'Intro 4k', 'Inspire 08 (Errenteria)'),
	'cns!rgba_luxo4k.avi'		=>	array('Luxo 4k', 'RGBA & Conspiracy', 'Intro 4k', 'Demoscene outreach tour 2007'),
	'rgba_kindernoiser.avi'		=>	array('Kindernoiser', 'RGBA', 'Intro 4k', 'Bcn party 111'),
	'sfl_integrated.mpg'		=>	array('Integrated software for omega devices', 'Ham & JosSs', 'Wild compo', 'Bcn party 111'),
	'rgba_stiletto.avi'			=>	array('Stiletto', 'RGBA', 'Intro 4k', 'Assembly 2007 (Helsinki)'),
	'xplsv_sokuseki.mp4'		=>	array('sokuseki', 'xplsv', 'Demo', 'Assembly 2007 (Helsinki)'),
	'xplsv_hofn.mp4'			=>	array('Hofn', 'xplsv', 'Demo', 'Intel demoscene compo 2007'),
	'spontz_cosmosis_remixed.avi'	=>	array('Cosmosis: Remixed', 'Spontz', 'Demo', 'Euskal Encounter 15 (Barakaldo)'),
	'purple_theuniverse_.avi'	=>	array('The universe is few unsorted blocks!', 'Purple studios', 'Demo', 'Euskal Encounter 15 (Barakaldo)'),
	'sgz_discharger.mp4'		=>	array('Discharger', 'Stravaganza', 'Demo', 'Euskal Encounter 15 (Barakaldo)'),
	'tlotb_conciencia.mp4'		=>	array('Conciencia', 'TLOTB', 'Demo', 'bcnparty 110 (Barcelona)'),
	'ts_bgparty07.avi'			=>	array('BGParty 2007 Invitation', 'TimeScratchers', 'Demo', 'bcnparty 110 (Barcelona)'),
	'xplsv_mudballs.mp4'		=>	array('Mudballs', 'xplsv', 'Demo', 'Sundown 2006 (Budleigh)'),
	'xplsv_tokyo.mp4'			=>	array('Tokyo', 'xplsv', 'Demo', 'Euskal Encounter 14 (Barakaldo)'),
	'so-themessage.mp4'			=>	array('The message', 'Sector Omega', 'Demo', 'bcnparty 101 (Barcelona)'),
	'wc_asier.avi'				=>	array('WC', 'Asier', 'Animación', 'Euskal Encounter 13 (Barakaldo)'),
	'xplsv_sp.mp4'				=>	array('Sound Pressure', 'xplsv', 'Demo', 'Euskal Encounter 13 (Barakaldo)'),
	'rgba_195_95_256.mp4'		=>	array('195/95/256', 'RGBA', 'Intro 64k', 'Euskal Encounter 13 (Barakaldo)'),
	'rgba_xenomorphic.avi'		=>	array('XenomorphiC', 'RGBA', 'Demo', 'ifparty 2005'),
);


foreach($playlist as $file => $details)
{
	echo "Processing $file\n";
	
	// Check the multiplexed file doesn't exist yet
	$multiplexed_filename = $tmp_dir . $file.".mpg";
	
	$vob_files[] = $multiplexed_filename;
	
	if(file_exists($multiplexed_filename))
	{
		echo $multiplexed_filename . " already exists, won't generate it again\n";
	}
	else
	{
		echo "Going to build $multiplexed_filename\n";
		
		$src_file = $movies_dir . $file;
		
		$output = shell_exec("ffmpeg -i $src_file 2>&1");
		
		// grab video properties
		preg_match("/(.+)Stream #\d\.(\d).*: Video(.*)\n/", $output, $matches);
		
		if(count($matches) == 0)
		{
			echo "Can't find the video properties!!\n";
			continue;
		}
		
		$video_stream_number = $matches[2];
		echo "Video stream number detected as $video_stream_number\n";
		
		preg_match("/(\d+)x(\d+)/", $matches[3], $dimensions);
		
		list(, $width, $height) = $dimensions;
		
		if(($width != $desired_width) || ($height != $desired_height))
		{
			// adjust
			$aspect_ratio = 1.0 * $width / $height;
			
			
			$final_width = $desired_width;
			$final_height = floor( ($desired_width / $aspect_ratio)/2) *2 ;
			
			if($final_height < $desired_height)
			{
				// padding
				$padding_size = round(0.5 * ($desired_height - $final_height));
				$padding_param = "-padtop $padding_size -padbottom $padding_size";
			}
			$size_param = $final_width . 'x' . $final_height;
		}
		else
		{
			$padding_param = "";
			$size_param = $desired_width . 'x' . $desired_height;
		}
		
		$tmp_video = $tmp_dir . $file . ".m2v";
		$tmp_audio = $tmp_dir . $file . ".m2a";
		
		// Extract video stream if not already there
		if(!file_exists($tmp_video) || filesize($tmp_video) == 0)
		{
			shell_exec("ffmpeg -i \"$src_file\" -y -vcodec mpeg2video -s $size_param $padding_param -r 25 -bufsize 1835008 -packetsize 2048 -muxrate 10080000 -aspect 4:3 -minrate 8000k -maxrate 8000k -b 8000k -threads 4 -strict very -f mpeg2video -map $video_stream_number:0 \"$tmp_video\"");
		}
		else
		{
			echo "FILE $tmp_video already exists, skipping\n";
		}
		
		// Extract audio stream if not already there
		if(!file_exists($tmp_audio) || filesize($tmp_audio) == 0)
		{
			shell_exec("ffmpeg -i \"$src_file\" -threads 4 -acodec mp2 -ab 256k -ac 2  \"$tmp_audio\"");
		}
		else
		{
			echo "FILE $tmp_audio already exists, skipping\n";
		}
		
		// Mux!!
		shell_exec("mplex -f 8 -o \"$multiplexed_filename\" \"$tmp_video\" \"$tmp_audio\"");
	}
}

	
// Build menus if they don't exist

// Mighty silence.mp2
$silence_file = $tmp_dir . "silence.mp2";
if(!file_exists($silence_file))
{
	shell_exec("ffmpeg -ar 48000 -t 10 -f s16le -acodec pcm_s16le -i /dev/zero -ab 64K -f mp2 -acodec mp2 -y \"$silence_file\"");
}	

$menus = array("cover", "producciones_01",  "producciones_02",  "producciones_03", "demoscene", "creditos", "extras");

foreach($menus as $menu)
{
	$menu_mpg = $tmp_dir . $menu . "_menu.mpg";
	$menu_xml = './' . $menu . '_menu.xml';
	
	if(!file_exists($menu_mpg) || filesize($menu_mpg) <= 0)
	{
		$tmp_m2v = $tmp_dir . $menu ."_menu.m2v";
		if(file_exists($tmp_m2v))
		{
			unlink($tmp_m2v);
		}
		
		shell_exec("ffmpeg -i \"{$menus_dir}{$menu}_png/$menu%03d.png\" -y -r 25 -b 8000k -aspect 4:3 -vcodec mpeg2video -strict very  \"$tmp_m2v\"");
		
		shell_exec("mplex -f 8 -o /dev/stdout \"$tmp_m2v\" \"$silence_file\" | spumux -v 2 \"$menu_xml\" > \"$menu_mpg\"");
	}
}

// Empty titles (for demoscene, extras, creditos)
$empty_m2v = $tmp_dir . "empty.m2v";
$empty_mpg = $tmp_dir . "empty.mpg";
shell_exec("pngtopnm ./assets/menu/empty_title.png | ppmtoy4m -n 1 -F25:1 -I t -A 59:54 -L -S 420mpeg2 | mpeg2enc -f 8 -n p -o \"$empty_m2v\"");
shell_exec("mplex -f 8 -o \"$empty_mpg\" \"$empty_m2v\" \"$silence_file\"");

echo "Now calling dvdauthor!\n";

shell_exec("rm -rv $output_dir");
shell_exec("dvdauthor -o $output_dir -x $dvdauthor_xml");

echo "Data\n";
shell_exec("mkdir $output_dir/extras");
shell_exec("cp -Rv $data_dir/* $output_dir/extras");

echo "And the ISO\n";
shell_exec("./bin/mkisofs -V escenaorg_dvd1 -dvd-video -r -udf $output_dir > $output_iso");

?>